
import { Camera, Component, EventMouse, geometry, input, Input, Node, physics, Vec2, _decorator } from 'cc';
const { ccclass, property } = _decorator;

const vec2Temp = new Vec2();
const rayTemp = new geometry.Ray();

@ccclass('RaycastExample')
export class RaycastExample extends Component {
    @property(Camera)
    readonly mainCamera: Camera = null;
    @property(Node)
    readonly pointNode: Node = null;

    start() {
        input.on(Input.EventType.MOUSE_MOVE, this.onMouseMove, this);
    }

    private onMouseMove(event: EventMouse): void {
        let location = event.getLocation(vec2Temp);
        let ray = this.mainCamera.screenPointToRay(location.x, location.y, rayTemp);
        if (physics.PhysicsSystem.instance.raycastClosest(ray)) {
            const result = physics.PhysicsSystem.instance.raycastClosestResult;
            console.log("onMouseMove ", result.collider.name, result.distance);
            this.pointNode.worldPosition = result.hitPoint;
            this.pointNode.forward = result.hitNormal.negative();
        }
    }
}

